#Add tag to all seed items
# Crops
execute as @e[type=item,nbt={Item:{id:"minecraft:wheat_seeds"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_crop_item
execute as @e[type=item,nbt={Item:{id:"minecraft:pumpkin_seeds"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_crop_item
execute as @e[type=item,nbt={Item:{id:"minecraft:melon_seeds"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_crop_item
execute as @e[type=item,nbt={Item:{id:"minecraft:beetroot_seeds"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_crop_item
execute as @e[type=item,nbt={Item:{id:"minecraft:torchflower_seeds"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_crop_item
execute as @e[type=item,nbt={Item:{id:"minecraft:carrot"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_crop_item
execute as @e[type=item,nbt={Item:{id:"minecraft:potato"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_crop_item
execute as @e[type=item,nbt={Item:{id:"minecraft:pitcher_pod"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_crop_item
execute as @e[type=item,nbt={Item:{id:"minecraft:sweet_berries"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_crop_item
# Saplings
execute as @e[type=item,nbt={Item:{id:"minecraft:oak_sapling"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_sapling_item
execute as @e[type=item,nbt={Item:{id:"minecraft:spruce_sapling"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_sapling_item
execute as @e[type=item,nbt={Item:{id:"minecraft:birch_sapling"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_sapling_item
execute as @e[type=item,nbt={Item:{id:"minecraft:jungle_sapling"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_sapling_item
execute as @e[type=item,nbt={Item:{id:"minecraft:acacia_sapling"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_sapling_item
execute as @e[type=item,nbt={Item:{id:"minecraft:dark_oak_sapling"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_sapling_item
execute as @e[type=item,nbt={Item:{id:"minecraft:cherry_sapling"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_sapling_item
execute as @e[type=item,nbt={Item:{id:"minecraft:mangrove_propagule"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_sapling_item
execute as @e[type=item,nbt={Item:{id:"minecraft:azalea"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_sapling_item
execute as @e[type=item,nbt={Item:{id:"minecraft:flowering_azalea"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_sapling_item
# Other
execute as @e[type=item,nbt={Item:{id:"minecraft:nether_wart"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_nether_wart_item
execute as @e[type=item,nbt={Item:{id:"minecraft:cocoa_beans"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_cocoa_beans_item
execute as @e[type=item,nbt={Item:{id:"minecraft:chorus_flower"}},tag=!smart_seeds_ignore] run tag @s add smart_seeds_chorus_item

#Add general tag to all these items
tag @e[tag=smart_seeds_crop_item] add smart_seeds_item
tag @e[tag=smart_seeds_sapling_item] add smart_seeds_item
tag @e[tag=smart_seeds_nether_wart_item] add smart_seeds_item
tag @e[tag=smart_seeds_cocoa_beans_item] add smart_seeds_item
tag @e[tag=smart_seeds_chorus_item] add smart_seeds_item

tag @e[tag=smart_seeds_crop_item] add smart_seeds_fast_growth_item
tag @e[tag=smart_seeds_sapling_item] add smart_seeds_slow_growth_item
tag @e[tag=smart_seeds_nether_wart_item] add smart_seeds_fast_growth_item
tag @e[tag=smart_seeds_cocoa_beans_item] add smart_seeds_fast_growth_item
tag @e[tag=smart_seeds_chorus_item] add smart_seeds_slow_growth_item


#Stop items from moving (comment out to disable)
# MOTION SETTING
function smart_seeds:prevent_motion


#Randomly increment age
execute as @e[tag=smart_seeds_item] store result score @s smart_seeds_random run random value 0..1
execute as @e[tag=smart_seeds_item,scores={smart_seeds_random=..1}] run scoreboard players add @s smart_seeds_age 1


#set age to 0 if not in a valid position
execute as @e[tag=smart_seeds_crop_item] at @s unless block ~ ~-0.5 ~ minecraft:farmland[moisture=7] run scoreboard players set @s smart_seeds_age 0
execute as @e[tag=smart_seeds_crop_item] at @s unless block ~ ~0.5 ~ minecraft:air run scoreboard players set @s smart_seeds_age 0

execute as @e[tag=smart_seeds_sapling_item] at @s unless block ~ ~-1 ~ #minecraft:dirt run scoreboard players set @s smart_seeds_age 0
execute as @e[tag=smart_seeds_sapling_item] at @s unless block ~ ~0 ~ minecraft:air run scoreboard players set @s smart_seeds_age 0

execute as @e[tag=smart_seeds_nether_wart_item] at @s unless block ~ ~-0.5 ~ minecraft:soul_sand run scoreboard players set @s smart_seeds_age 0
execute as @e[tag=smart_seeds_nether_wart_item] at @s unless block ~ ~0.5 ~ minecraft:air run scoreboard players set @s smart_seeds_age 0

execute as @e[tag=smart_seeds_chorus_item] at @s unless block ~ ~-1 ~ minecraft:end_stone run scoreboard players set @s smart_seeds_age 0
execute as @e[tag=smart_seeds_chorus_item] at @s unless block ~ ~0 ~ minecraft:air run scoreboard players set @s smart_seeds_age 0

execute as @e[tag=smart_seeds_cocoa_beans_item] at @s if block ~1 ~ ~ minecraft:jungle_log run tag @s add smart_seeds_valid_cocoa_position
execute as @e[tag=smart_seeds_cocoa_beans_item] at @s if block ~-1 ~ ~ minecraft:jungle_log run tag @s add smart_seeds_valid_cocoa_position
execute as @e[tag=smart_seeds_cocoa_beans_item] at @s if block ~ ~ ~1 minecraft:jungle_log run tag @s add smart_seeds_valid_cocoa_position
execute as @e[tag=smart_seeds_cocoa_beans_item] at @s if block ~ ~ ~-1 minecraft:jungle_log run tag @s add smart_seeds_valid_cocoa_position
execute as @e[tag=smart_seeds_cocoa_beans_item,tag=!smart_seeds_valid_cocoa_position] run scoreboard players set @s smart_seeds 0
execute as @e[tag=smart_seeds_cocoa_beans_item] at @s unless block ~ ~ ~ minecraft:air run scoreboard players set @s smart_seeds_age 0



#if the age is higher than a threshold, add tag that plants this seed
# 10 results in 1s on average
# enter one less than you actually want (for example 9 instead of 10)
# TIME SETTING
execute as @e[tag=smart_seeds_fast_growth_item,scores={smart_seeds_age=7..}] at @s align xyz unless entity @e[tag=smart_seeds_plant,distance=..0.5] run tag @s add smart_seeds_plant
execute as @e[tag=smart_seeds_slow_growth_item,scores={smart_seeds_age=127..}] at @s align xyz unless entity @e[tag=smart_seeds_plant,distance=..0.5] run tag @s add smart_seeds_plant


#place the corresponding block to the item
# crops
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:wheat_seeds"}}] at @s run setblock ~ ~0.5 ~ minecraft:wheat
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:pumpkin_seeds"}}] at @s run setblock ~ ~0.5 ~ minecraft:pumpkin_stem
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:melon_seeds"}}] at @s run setblock ~ ~0.5 ~ minecraft:melon_stem
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:beetroot_seeds"}}] at @s run setblock ~ ~0.5 ~ minecraft:beetroots
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:torchflower_seeds"}}] at @s run setblock ~ ~0.5 ~ minecraft:torchflower_crop
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:carrot"}}] at @s run setblock ~ ~0.5 ~ minecraft:carrots
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:potato"}}] at @s run setblock ~ ~0.5 ~ minecraft:potatoes
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:pitcher_pod"}}] at @s run setblock ~ ~0.5 ~ minecraft:pitcher_crop
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:sweet_berries"}}] at @s run setblock ~ ~0.5 ~ minecraft:sweet_berry_bush
# saplings
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:oak_sapling"}}] at @s run setblock ~ ~ ~ minecraft:oak_sapling
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:spruce_sapling"}}] at @s run setblock ~ ~ ~ minecraft:spruce_sapling
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:birch_sapling"}}] at @s run setblock ~ ~ ~ minecraft:birch_sapling
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:jungle_sapling"}}] at @s run setblock ~ ~ ~ minecraft:jungle_sapling
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:acacia_sapling"}}] at @s run setblock ~ ~ ~ minecraft:acacia_sapling
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:dark_oak_sapling"}}] at @s run setblock ~ ~ ~ minecraft:dark_oak_sapling
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:cherry_sapling"}}] at @s run setblock ~ ~ ~ minecraft:cherry_sapling
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:mangrove_propagule"}}] at @s run setblock ~ ~ ~ minecraft:mangrove_propagule
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:azalea"}}] at @s run setblock ~ ~ ~ minecraft:azalea
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:flowering_azalea"}}] at @s run setblock ~ ~ ~ minecraft:flowering_azalea
# cocoa beans
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:cocoa_beans"}}] at @s if block ~1 ~ ~ minecraft:jungle_log run setblock ~ ~ ~ minecraft:cocoa[facing=east]
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:cocoa_beans"}}] at @s if block ~-1 ~ ~ minecraft:jungle_log run setblock ~ ~ ~ minecraft:cocoa[facing=west]
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:cocoa_beans"}}] at @s if block ~ ~ ~1 minecraft:jungle_log run setblock ~ ~ ~ minecraft:cocoa[facing=south]
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:cocoa_beans"}}] at @s if block ~ ~ ~-1 minecraft:jungle_log run setblock ~ ~ ~ minecraft:cocoa[facing=north]
# other
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:nether_wart"}}] at @s run setblock ~ ~0.5 ~ minecraft:nether_wart
execute as @e[tag=smart_seeds_plant,nbt={Item:{id:"minecraft:chorus_flower"}}] at @s run setblock ~ ~ ~ minecraft:chorus_flower


#reduce the amount of items in the item entity
tag @e[tag=smart_seeds_plant] add smart_seeds_reduce_item_count
function smart_seeds:reduce_item_count
tag @e[tag=smart_seeds_reduce_item_count] remove smart_seeds_reduce_item_count

#reset item so it doesn't activate again instantly
scoreboard players set @e[tag=smart_seeds_plant] smart_seeds_age 0
tag @e[tag=smart_seeds_plant] remove smart_seeds_plant